'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _requestPromise = require('request-promise');

var _requestPromise2 = _interopRequireDefault(_requestPromise);

var _toughCookie = require('tough-cookie');

var _events = require('events');

var _loginEncrypt = require('./loginEncrypt.js');

var _loginEncrypt2 = _interopRequireDefault(_loginEncrypt);

var _config = require('./config.js');

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var log = (0, _debug2.default)('ncc:credentials');

function hookCookieJar(cookieJar) {
  // Request.js does some weird stuff.
  // ... Why am I doing this thing.
  cookieJar.setCookie = function (cookieOrStr, uri, options, syncCb) {
    if (syncCb) {
      return _toughCookie.CookieJar.prototype.setCookie.apply(this, arguments);
    }
    return this.setCookieSync(cookieOrStr, uri, options || {});
  };
  cookieJar.getCookieString = function () {
    if (arguments[arguments.length - 1] instanceof Function) {
      return _toughCookie.CookieJar.prototype.getCookieString.apply(this, arguments);
    }
    return this.getCookieStringSync.apply(this, arguments);
  };
  cookieJar.getCookies = function () {
    if (arguments[arguments.length - 1] instanceof Function) {
      return _toughCookie.CookieJar.prototype.getCookies.apply(this, arguments);
    }
    return this.getCookiesSync.apply(this, arguments);
  };
}

var Credentials = (function (_EventEmitter) {
  _inherits(Credentials, _EventEmitter);

  function Credentials(username, password, cookieJar) {
    _classCallCheck(this, Credentials);

    // TODO in-memory password encryption
    // Note that username/password should belong to cookieJar

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Credentials).call(this));

    _this.username = username;
    _this.password = password;
    _this.setCookieJar(cookieJar);
    return _this;
  }

  _createClass(Credentials, [{
    key: 'setCookieJar',
    value: function setCookieJar(cookieJar) {
      if (cookieJar != null) {
        log('Received already existing cookie jar; deserializing');
        this.cookieJar = _toughCookie.CookieJar.deserializeSync(cookieJar);
      } else {
        log('Creating new cookie jar');
        this.cookieJar = new _toughCookie.CookieJar();
      }
      log('Hooking cookie jar');
      hookCookieJar(this.cookieJar);
    }
  }, {
    key: 'getCookieJar',
    value: function getCookieJar() {
      return this.cookieJar.serializeSync();
    }
  }, {
    key: 'validateLogin',
    value: function validateLogin() {
      log('Validating login status');
      return (0, _requestPromise2.default)({
        url: _config.CHAT_HOME_URL,
        jar: this.cookieJar,
        strictSSL: false,
        resolveWithFullResponse: true
      }).then(function (response) {
        if (response.request.uri.href.indexOf('nidlogin.login?') !== -1) {
          log('Not logged in; rejecting promise');
          return Promise.reject();
        } else {
          var pattern = /var g_sUserId = "([^'\n]+)";/;
          var matched = pattern.exec(response.body);
          log('Logged in as %s; resolving promise', matched[1]);
          return Promise.resolve(matched[1]);
        }
      });
    }
  }, {
    key: 'login',
    value: function login() {
      var _this2 = this;

      log('Starting logging in');
      // Empty cookie jar
      log('Creating new cookie jar');
      this.cookieJar = new _toughCookie.CookieJar();
      hookCookieJar(this.cookieJar);
      log('Receiving RSA encryption key');
      // Fetch RSA login key from the server
      return (0, _requestPromise2.default)('http://static.nid.naver.com/enclogin/keys.nhn').then(function (keyString) {
        // Encrypt key

        var _encryptKey = (0, _loginEncrypt2.default)(keyString, _this2.username, _this2.password);

        var keyName = _encryptKey.keyName;
        var key = _encryptKey.key;

        log('Sending encrypted login request');
        // Send login request
        return (0, _requestPromise2.default)({
          url: 'https://nid.naver.com/nidlogin.login',
          headers: {
            'Content-Type': 'application/x-www-form-urlencoded',
            'Accept': 'text/plain'
          },
          method: 'POST',
          form: {
            enctp: 1,
            encnm: keyName,
            svctype: 0,
            'enc_url': 'http0X0.0000000000001P-10220.0000000.000000www.naver.com',
            url: 'www.naver.com',
            'smart_level': 1,
            encpw: key
          },
          jar: _this2.cookieJar
        });
      }).then(function () {
        var cookieText = _this2.cookieJar.getCookieString('https://nid.naver.com/', {});
        if (cookieText.indexOf('NID_AUT') !== -1) {
          log('Successfully logged in');
          _this2.emit('login');
          return Promise.resolve();
        } else {
          log('Failed to log in');
          return Promise.reject('Invalid username or password');
        }
      }).catch(function (e) {
        _this2.emit('error', e);
        throw e;
      });
    }
  }, {
    key: 'logout',
    value: function logout() {
      // Empty cookie jar
      this.cookieJar = new _toughCookie.CookieJar();
      hookCookieJar(this.cookieJar);
      log('Logging out');
      this.emit('logout');
      return Promise.resolve();
    }
  }, {
    key: 'toJSON',
    value: function toJSON() {
      return {};
    }
  }, {
    key: 'inspect',
    value: function inspect() {
      return 'Credentials information';
    }
  }]);

  return Credentials;
})(_events.EventEmitter);

exports.default = Credentials;