'use strict';

var _slicedToArray = (function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; })();

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = encryptKey;

var _crypto = require('crypto');

var _crypto2 = _interopRequireDefault(_crypto);

var _asn = require('asn1');

var _constants = require('constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function linebrk(str, maxLen) {
  var res = '';
  var i = 0;
  while (i + maxLen < str.length) {
    res += str.substring(i, i + maxLen) + '\n';
    i += maxLen;
  }
  return res + str.substring(i, str.length);
}

function getEncChar(value) {
  return String.fromCharCode(value.length) + value;
}

function encryptKey(keyString, username, password) {
  var _keyString$split = keyString.split(',');

  var _keyString$split2 = _slicedToArray(_keyString$split, 4);

  var sessionKey = _keyString$split2[0];
  var keyName = _keyString$split2[1];
  var nValue = _keyString$split2[2];
  var eValue = _keyString$split2[3];
  // Parse eValue, nValue

  var keyN = new Buffer(nValue, 'hex');
  var keyE = parseInt(eValue, 16);
  var size = keyN.length + 512;
  // Create PEM encoded RSA public key
  var bodyWriter = new _asn.Ber.Writer({ size: size });
  bodyWriter.startSequence();
  bodyWriter.writeBuffer(keyN, 2);
  bodyWriter.writeInt(keyE);
  bodyWriter.endSequence();
  var key = '-----BEGIN RSA PUBLIC KEY-----\n';
  key += linebrk(bodyWriter.buffer.toString('base64'), 64);
  key += '\n-----END RSA PUBLIC KEY-----\n';
  // Encode credentials using PEM key
  var encryptBuffer = new Buffer(getEncChar(sessionKey) + getEncChar(username) + getEncChar(password));
  var encrypted = _crypto2.default.publicEncrypt({
    key: key, padding: _constants.RSA_PKCS1_PADDING
  }, encryptBuffer);
  return {
    keyName: keyName, key: encrypted.toString('hex')
  };
}