'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _lodash = require('lodash.values');

var _lodash2 = _interopRequireDefault(_lodash);

var _translate = require('./translate.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Room = (function () {
  function Room(session, id, name) {
    _classCallCheck(this, Room);

    this.session = session;
    this.id = id;
    this.name = name;
    this.isPublic = null;
    this.is1to1 = null;
    this.cafe = null;
    this.maxUserCount = null;
    this.userCount = null;
    this.users = {};
    this.joined = true;
    this.master = null;
    this.updated = null;
    this.lastMessage = null;
    this.loading = false;
    this.load = _translate.ROOM_LOAD_BARE;
  }

  _createClass(Room, [{
    key: 'toJSON',
    value: function toJSON() {
      var users = (0, _lodash2.default)(this.users);
      users = users.map(function (user) {
        return user.id;
      });
      return Object.assign({}, this, {
        cafe: this.cafe && this.cafe.id,
        users: users,
        session: undefined
      });
    }
  }, {
    key: 'inspect',
    value: function inspect() {
      return (this.name || this.id) + (this.joined ? '' : ' (Unjoined)');
    }
  }]);

  return Room;
})();

exports.default = Room;