'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = uploadImage;
var UPLOAD_URL = exports.UPLOAD_URL = 'https://up.cafe.naver.com';
var UPLOAD_PIC_URL = exports.UPLOAD_PIC_URL = '/AttachChatPhotoForJindoUploader.nhn';

function getCallbackFn() {
  // Mimic Jindo's behaviour
  return 'tmpFrame_' + (Math.floor(Math.random() * 9000 + 1000) + '_func');
}

// Upload image to the server. This doesn't send image to the chat, though.
function uploadImage(request, readStream) {
  var options = arguments.length <= 2 || arguments[2] === undefined ? null : arguments[2];

  var req = request(UPLOAD_URL + UPLOAD_PIC_URL);
  var form = req.form();
  form.append('photo', readStream, options);
  form.append('callback', '/html/AttachImageDummyCallback.html');
  form.append('callback_func', getCallbackFn());
  return req.then(function (body) {
    var regex = /\]\)\('([^']+)'\);/;
    var unpacked = regex.exec(body);
    if (unpacked.length < 2) {
      // Can we be more descriptive?
      throw new Error('File transfer failed');
    }
    unpacked = unpacked[1];
    var data = JSON.parse(unpacked);
    var param = {
      path: data.savedPath,
      fileSize: data.size,
      width: data.width,
      height: data.height
    };
    return param;
  });
}